SystemOrganization addCategory: #'Egg-NBEina'!
SystemOrganization addCategory: #'Egg-Evas'!
SystemOrganization addCategory: #'Egg-SDL'!
SystemOrganization addCategory: #'Egg-Examples'!
SystemOrganization addCategory: #'Egg-Core'!
SystemOrganization addCategory: #'Egg-Window'!
SystemOrganization addCategory: #'Egg-NBEvas'!
SystemOrganization addCategory: #'Egg-Tests-Evas'!

TestCase subclass: #EvasTest
	instanceVariableNames: 'egg evas stage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

EvasTest subclass: #EvasImageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

!EvasImageTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 19:36'!
testImage1
	| img top |
	img := self addTilesetImage.
	self assert: (img loadError = 'No error on load').
	top := evas topAt: 50 @ 50.
	self assert: top = img
! !

EvasTest subclass: #EvasRectangleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Tests-Evas'!

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:01'!
testRect1
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 50 @ 50.
	self assert: top = rect
! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:01'!
testRect2
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 500 @ 500.
	self assert: top = nil! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:04'!
testRect3
	| rect top |
	rect := self addRectangle: (Rectangle origin: 100 @ 100 extent: 100 @ 100 ).
	top := evas topAt: 100 @ 100.
	self assert: top = rect! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:05'!
testRect4
	| rect top |
	rect := self addRectangle: (Rectangle origin: -100 @ -100 extent: 100 @ 100 ).
	top := evas topAt: -50 @ -50.
	self assert: top = rect! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:07'!
testRect5
	| rect1 rect2 top |
	rect1 := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	rect2 := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	top := evas topAt: 50 @ 50.
	self assert: top = rect2! !

!EvasRectangleTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:18'!
testRect6
	| rect top |
	rect := self addRectangle: (Rectangle origin: 0 @ 0 extent: 100 @ 100 ).
	rect moveTo: 200 @ 200.
	top := evas topAt: 50 @ 50.
	self assert: top = nil.
	top := evas topAt: 250 @ 250.
	self assert: top = rect! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 00:37'!
addRectangle: aRectangle
	|rect|
	rect := EvasRectangle new.
	rect x: aRectangle origin x; y: aRectangle origin y; width: aRectangle width; height: aRectangle height; color: Color random.
	stage add: rect.
	^rect.
	
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 19:32'!
addTilesetImage
	|image|
	image := EvasImage new.
	image x:0; y:0.
	image sourceFile: '/home/egor/pharo/tiles/TileSetVX___Global_4.png'.
	stage add: image.
	^image.
	
! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:00'!
setUp
	egg := Egg new.
	evas := egg evas.
	stage := egg stage.
	egg run.! !

!EvasTest methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/13/2012 16:00'!
tearDown
	egg finalize.! !

Link subclass: #EvasObject
	instanceVariableNames: 'x y width height color visible handler callbacks nbCallbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

EvasObject subclass: #EvasImage
	instanceVariableNames: 'sourceFile key imageWidth imageHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 11/15/2012 02:04'!
bindOn: aNBEvas

	handler := aNBEvas addImage.! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 4/8/2012 00:11'!
getNBEvasObjectFor: aNBEvas

	^ aNBEvas addImage.! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 01:07'!
imageHeight
	^ imageHeight! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 4/28/2012 20:35'!
imageHeight: anObject
	imageHeight := anObject.
	self updateImageSize.! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 01:07'!
imageWidth
	^ imageWidth! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 4/28/2012 20:35'!
imageWidth: anObject
	imageWidth := anObject.
	self updateImageSize.! !

!EvasImage methodsFor: 'initialize-release' stamp: 'EgorScorik 1/5/2012 01:21'!
initialize 

	super initialize.
	imageWidth := 0.
	imageHeight := 0.
	sourceFile := ''.
	key := ''.
! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:34'!
key
	^ key! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:48'!
key: anObject
	key := anObject.
	self updateFile.! !

!EvasImage methodsFor: 'errors' stamp: 'EgorScorik 1/5/2012 00:31'!
loadError
	^ self handler loadErrorFromCode: self handler loadErrorCode! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:34'!
sourceFile
	^ sourceFile! !

!EvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 23:47'!
sourceFile: anObject
	sourceFile := anObject.
	self updateFile! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	self updateFile.
	! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 01:36'!
updateFile
	handler
		ifNotNil: [ 
			handler setFile: sourceFile key: key.
			self updateImageSize ]! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/5/2012 21:35'!
updateImageSize
	handler
		ifNotNil: [ 
			handler getImageInfo.
			imageWidth := handler imageWidth.
			imageHeight := handler imageHeight.
			self width: imageWidth.
			self height: imageHeight ]! !

!EvasImage methodsFor: 'updating' stamp: 'EgorScorik 1/5/2012 00:09'!
updateSize
	(width = 0 or: height = 0)
		ifFalse: [ handler ifNotNil: [ handler width: width height: height ] ]! !

EvasObject subclass: #EvasLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasLine methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:05'!
bindOn: aNBEvas

	handler := aNBEvas addLine.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 02:46'!
addCallback: callback withTypeId: type andKey: key
	| cb |
	cb := NBEvasObjectCallback  on: [:data :e :obj :params  | callback cull: params ].
	handler addCallback: cb type: type data: nil.	
	(callbacks at: key ifAbsentPut: [OrderedCollection new]) add: callback.
	(nbCallbacks at: key ifAbsentPut: [OrderedCollection new]) add: cb.! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:03'!
bindOn: aNBEvas

	self subclassResponsibility.! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
color
	^ color! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:28'!
color: anObject
	color := anObject.
	self updateColor.! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 4/8/2012 00:53'!
free

	handler ifNotNil: [ handler free ].! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:34'!
group
	^ group! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 4/8/2012 00:34'!
group: anObject
	group := anObject! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:35'!
handler
	^ handler! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:35'!
handler: nbEvasObject
	^ handler := nbEvasObject! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
height
	^ height! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:32'!
height: anObject
	height := anObject.
	self updateSize! !

!EvasObject methodsFor: 'initialize-release' stamp: 'EgorScorik 11/16/2012 01:46'!
initialize 

	callbacks := Dictionary new.
	nbCallbacks := Dictionary new.
	
	x := 0.
	y := 0.
	width := 0.
	height := 0.
	visible := true.! !

!EvasObject methodsFor: 'move-resize' stamp: 'EgorScorik 5/13/2012 16:20'!
moveTo: aPoint

	x := aPoint x.
	y := aPoint y.
	self updateXY.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:52'!
onFocusIn: callback

	self addCallback: callback withTypeId: 12 andKey: #focusIn.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:52'!
onFocusOut: callback

	self addCallback: callback withTypeId: 13 andKey: #focusOut.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:50'!
onFree: callback

	self addCallback: callback withTypeId: 9 andKey: #free.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:54'!
onHide: callback

	self addCallback: callback withTypeId: 15 andKey: #hide.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:51'!
onKeyDown: callback

	self addCallback: callback withTypeId: 10 andKey: #keyDown.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:51'!
onKeyUp: callback

	self addCallback: callback withTypeId: 11 andKey: #keyUp.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:48'!
onMouseDown: callback

	self addCallback: callback withTypeId: 2 andKey: #mouseDown.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:44'!
onMouseIn: callback

	self addCallback: callback withTypeId: 0 andKey: #mouseIn.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:49'!
onMouseMove: callback

	self addCallback: callback withTypeId: 4 andKey: #mouseMove.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:44'!
onMouseOut: callback

	self addCallback: callback withTypeId: 1 andKey: #mouseOut.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:49'!
onMouseUp: callback

	self addCallback: callback withTypeId: 3 andKey: #mouseUp.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:49'!
onMouseWheel: callback

	self addCallback: callback withTypeId: 5 andKey: #mouseWheel.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:54'!
onMove: callback

	self addCallback: callback withTypeId: 16 andKey: #move.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:54'!
onResize: callback

	self addCallback: callback withTypeId: 17 andKey: #resize.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:56'!
onRestack: callback

	self addCallback: callback withTypeId: 18 andKey: #restack.! !

!EvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 01:53'!
onShow: callback

	self addCallback: callback withTypeId: 14 andKey: #show.! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	self
		updateXY;
		updateSize;
		updateColor;
		updateVisibility! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/5/2012 00:11'!
updateColor
	(handler isNil or: color isNil) ifFalse: [
			handler
				colorR: (color red * 255) asInteger
				G: (color green * 255) asInteger
				B: (color blue * 255) asInteger
				A: (color alpha * 255) asInteger ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 4/8/2012 00:46'!
updateHandler: anEvas
	anEvas ifNil: [ ^self ].
	self handler: (self getNBEvasObjectFor: anEvas handler).
	self update! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:29'!
updateSize
	handler ifNotNil: [ handler width: width height: height ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:06'!
updateVisibility
	handler
		ifNotNil: [ 
			self visible
				ifTrue: [ handler show ]
				ifFalse: [ handler hide ] ]! !

!EvasObject methodsFor: 'update' stamp: 'EgorScorik 1/4/2012 22:29'!
updateXY
	handler ifNotNil: [ handler moveToX: x Y: y ]! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
visible
	^ visible! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:07'!
visible: anObject
	visible := anObject.
	self updateVisibility! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
width
	^ width! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
width: anObject
	width := anObject.
	self updateSize! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
x
	^ x! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
x: anObject
	x := anObject.
	self updateXY! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 21:45'!
y
	^ y! !

!EvasObject methodsFor: 'accessing' stamp: 'EgorScorik 1/4/2012 22:31'!
y: anObject
	y := anObject.
	self updateXY! !

EvasObject subclass: #EvasPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasPolygon methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:06'!
bindOn: aNBEvas

	handler := aNBEvas addPolygon.! !

EvasObject subclass: #EvasRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasRectangle methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:26'!
bindOn: aNBEvas

	handler := aNBEvas addRectangle.! !

!EvasRectangle methodsFor: 'update' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	! !

EvasObject subclass: #EvasText
	instanceVariableNames: 'fontName text fontSize fontSource'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 11/15/2012 02:07'!
bindOn: aNBEvas

	handler := aNBEvas addText.! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:32'!
font
	^ fontName! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:32'!
font: anObject
	fontName := anObject.
	self updateFont.! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 03:11'!
font: anObject size: size
	fontName := anObject.
	fontSize := size.
	self updateFont! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:06'!
fontSize
	^ fontSize! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:25'!
fontSize: anObject
	fontSize := anObject.
	self updateFont.
	! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:31'!
fontSource
	^ fontSource! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:31'!
fontSource: anObject
	fontSource := anObject.
	self updateFontSource.! !

!EvasText methodsFor: 'initialize-release' stamp: 'EgorScorik 1/6/2012 02:05'!
initialize 

	super initialize.
	fontName := 'Arial'.
	text := ''.
	fontSize := 12.
! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:03'!
text
	^ text! !

!EvasText methodsFor: 'accessing' stamp: 'EgorScorik 1/6/2012 02:12'!
text: anObject
	text := anObject.
	self updateText! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/28/2012 23:22'!
update
	super update.
	self updateFont.
	self updateFontSource.
	self updateText.! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:14'!
updateFont
	handler ifNotNil: [ handler setFont: fontName size: fontSize. ]! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:31'!
updateFontSource
	handler ifNotNil: [ fontSource ifNotNil: [ handler setFontSource: fontSource ] ]! !

!EvasText methodsFor: 'updating' stamp: 'EgorScorik 1/6/2012 02:12'!
updateText
	handler ifNotNil: [ handler setText: text ]! !

EvasObject subclass: #EvasTextblock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!EvasTextblock methodsFor: 'update' stamp: 'EgorScorik 11/15/2012 02:07'!
bindOn: aNBEvas

	handler := aNBEvas addTextblock.! !

NBFFICallback subclass: #NBEcoreEvasCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

!NBEcoreEvasCallback class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/1/2012 00:14'!
fnSpec

	^ #(void (void* ee))! !

NBFFICallback subclass: #NBEvasObjectCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasObjectCallback class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/16/2012 00:42'!
fnSpec

	^ #(void (void*, void*, void*, void*))! !

Object subclass: #Egg
	instanceVariableNames: 'handler process fps session callbacks evas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
callbacks
	^ callbacks! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
callbacks: anObject
	callbacks := anObject! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 10/15/2012 02:29'!
checkSession
	session = NativeBoost uniqueSessionObject
		ifFalse: [ 
			self refreshHandlers.
			session := NativeBoost uniqueSessionObject ]! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 10/20/2012 14:40'!
defaultFPS

	^60.! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
evas
	^ evas! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
evas: anObject
	evas := anObject! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 10/20/2012 19:48'!
fps
	^ fps! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 10/20/2012 19:48'!
fps: anObject
	fps := anObject! !

!Egg methodsFor: 'initialize-release' stamp: 'EgorScorik 11/19/2012 22:56'!
free

	self stop.
	handler ifNotNil: [
		handler unregisterForEvents.
		handler free.
		handler := nil.
	].! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
handler
	^ handler! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
handler: anObject
	handler := anObject! !

!Egg methodsFor: 'window' stamp: 'EgorScorik 10/20/2012 16:35'!
hide

	handler hide.! !

!Egg methodsFor: 'initialize-release' stamp: 'EgorScorik 11/19/2012 23:46'!
initialize
	
	super initialize.
	NBEcoreEvas init.
	handler := NBEcoreEvas newOn: 'opengl_x11' x: 0 y: 0 width: 1024 height: 768 options: nil.
	session := NativeBoost uniqueSessionObject.
	fps := self defaultFPS.
	callbacks := Dictionary new.
	self setupDefaultCallbacks.
	self show.
	handler registerForEvents.
	evas := Evas new.
	evas handler: handler evas.
	self start.! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 11/4/2012 19:31'!
mainLoop
	| ms msForDelay |
	ms := Time millisecondClockValue.
	self checkSession.
	NBEcore iterate.
	ms := Time millisecondClockValue - ms.
	msForDelay := (1000.0 / fps) - ms.
	msForDelay > 0
		ifTrue: [ (Delay forMilliseconds: msForDelay) wait ]! !

!Egg methodsFor: 'callbacks' stamp: 'EgorScorik 11/1/2012 01:42'!
onDestroy
	self halt.
	self stop.
	self free.! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
process
	^ process! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
process: anObject
	process := anObject! !

!Egg methodsFor: 'examples' stamp: 'EgorScorik 11/16/2012 00:19'!
rect

	^self evas addRectangle: (Rectangle origin: 0@0 extent: 100@100).! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 10/15/2012 02:29'!
refreshHandlers! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
session
	^ session! !

!Egg methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:27'!
session: anObject
	session := anObject! !

!Egg methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 00:25'!
setupDefaultCallbacks
	| cb |
	cb := NBEcoreEvasCallback on: [:ee | self onDestroy].
	handler setOnDestroyCallback: cb. 
	callbacks add: (#onDestroy -> cb).! !

!Egg methodsFor: 'window' stamp: 'EgorScorik 10/20/2012 16:35'!
show

	handler show.! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 10/20/2012 16:51'!
start
	
	 self stop.
	process := [
		[ [ self mainLoop ] repeat ] ifError: [ process debug ]
	] fork! !

!Egg methodsFor: 'main-loop' stamp: 'EgorScorik 10/20/2012 16:45'!
stop
	
	process ifNotNil: [ process terminate ].! !

Object subclass: #Evas
	instanceVariableNames: 'handler children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Evas'!

!Evas methodsFor: 'adding' stamp: 'EgorScorik 11/15/2012 02:26'!
add: anObject
	
	anObject bindOn: self handler.
	self children add: anObject.
	anObject update.
	
	! !

!Evas methodsFor: 'adding' stamp: 'EgorScorik 11/15/2012 02:18'!
addRectangle: aRectangle
	|rect|
	rect := EvasRectangle new.
	rect
		x: aRectangle origin x;
		y: aRectangle origin y;
		width: aRectangle width;
		height: aRectangle height;
		color: Color random.
		
	self add: rect.
	^rect.
	! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
children
	^ children! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
children: anObject
	children := anObject! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
handler
	^ handler! !

!Evas methodsFor: 'accessing' stamp: 'EgorScorik 11/15/2012 01:39'!
handler: anObject
	handler := anObject! !

!Evas methodsFor: 'initialize-release' stamp: 'EgorScorik 11/15/2012 01:57'!
initialize

	self children: LinkedList new.! !

NBExternalObject subclass: #NBEcore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

!NBEcore class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/1/2012 00:39'!
ffiCalloutOptions

	 ^ #( optMayGC )! !

!NBEcore class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:41'!
iterate
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_main_loop_iterate (void))! !

!NBEcore class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:40'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libecore.so'! !

NBExternalObject subclass: #NBEcoreEvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-Core'!

!NBEcoreEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/1/2012 00:21'!
ffiCalloutOptions

	 ^ #( optMayGC )! !

!NBEcoreEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:37'!
init
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(int ecore_evas_init (void))! !

!NBEcoreEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:35'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libecore_evas.so'! !

!NBEcoreEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 20:27'!
newOn: engine_name x: x y: y width: w height: h options: options
"/**
 * @brief Creates a new Ecore_Evas based on engine name and common parameters.
 *
 * @param engine_name engine name as returned by
 *        ecore_evas_engines_get() or @c NULL to use environment variable
 *        ECORE_EVAS_ENGINE, that can be undefined and in this case
 *        this call will try to find the first working engine.
 * @param x horizontal position of window (not supported in all engines)
 * @param y vertical position of window (not supported in all engines)
 * @param w width of window
 * @param h height of window
 * @param extra_options string with extra parameter, dependent on engines
 *        or @ NULL. String is usually in the form: 'key1=value1;key2=value2'.
 *        Pay attention that when getting that from shell commands, most
 *        consider ';' as the command terminator, so you need to escape
 *        it or use quotes.
 *
 * @return Ecore_Evas instance or @c NULL if creation failed.
 */
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(#NBEcoreEvas ecore_evas_new (String engine_name, int x, int y, int w, int h, String options)) options: #( optStringOrNull )! !

!NBEcoreEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:37'!
shutdown
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(int ecore_evas_shutdown (void))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/15/2012 02:20'!
evas
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(NBEvas ecore_evas_get (#NBEcoreEvas self))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:37'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_evas_free (#NBEcoreEvas self))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:38'!
hide
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_evas_hide (#NBEcoreEvas self))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:37'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:44'!
registerForEvents
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_evas_input_event_register (#NBEcoreEvas self))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/1/2012 00:23'!
setOnDestroyCallback: callback
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_evas_callback_destroy_set (#NBEcoreEvas self, NBEcoreEvasCallback callback))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:40'!
show
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_evas_show (#NBEcoreEvas self))! !

!NBEcoreEvas methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/20/2012 19:44'!
unregisterForEvents
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^self nbCall: #(void ecore_evas_input_event_unregister (#NBEcoreEvas self))! !

NBExternalObject subclass: #NBEinaIterator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEina'!

!NBEinaIterator class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libeina.so'! !

!NBEinaIterator methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 13:17'!
asArray
	| pointer array |
	array := OrderedCollection new.
	[ pointer := self next ] whileNotNil: [ array add: pointer ].
	^ array! !

!NBEinaIterator methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:27'!
asStringArray
	^self asArray collect: [:each | each readString. ]! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 12:19'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void eina_iterator_free (#NBEinaIterator self))! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:13'!
getNext: data
"
/**
 * @brief Return the value of the current element and go to the next one.
 *
 * @param iterator The iterator.
 * @param data The data of the element.
 * @return #EINA_TRUE on success, #EINA_FALSE otherwise.
 *
 * This function returns the value of the current element pointed by
 * @p iterator in @p data, then goes to the next element. If @p
 * iterator is @c NULL or if a problem occurred, #EINA_FALSE is
 * returned, otherwise #EINA_TRUE is returned.
 */
EAPI Eina_Bool eina_iterator_next(Eina_Iterator *iterator,
                                  void         **data) EINA_ARG_NONNULL(1, 2) EINA_WARN_UNUSED_RESULT;
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(int eina_iterator_next (#NBEinaIterator self, NBExternalAddress* data))! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 12:15'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEinaIterator methodsFor: 'as yet unclassified' stamp: 'EgorScorik 5/7/2012 13:11'!
next
	|result|
	result := NBExternalAddress new.
	
	^((self getNext: result) = 1) ifTrue: [result ] ifFalse: [nil].! !

NBExternalObject subclass: #NBEinaList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEina'!

!NBEinaList class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libeina.so'! !

!NBEinaList methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:33'!
asArray
	| iterator array |
	iterator := self iterator.
	array := iterator asArray.
	iterator free.
	^ array! !

!NBEinaList methodsFor: 'converting' stamp: 'EgorScorik 5/7/2012 12:34'!
asStringArray
	| iterator array |
	iterator := self iterator.
	array := iterator asStringArray.
	iterator free.
	^ array! !

!NBEinaList methodsFor: 'accessing' stamp: 'EgorScorik 5/7/2012 12:14'!
iterator
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEinaIterator eina_list_iterator_new (#NBEinaList self))! !

!NBEinaList methodsFor: 'nativeboost' stamp: 'EgorScorik 2/11/2012 20:24'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

NBExternalObject subclass: #NBEvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvas commentStamp: '<historical>' prior: 0!
I am native boost wrapper for libevas general functions on my class side and Evas (canvas instance) on my instance side.

http://docs.enlightenment.org/auto/evas/modules.html!

!NBEvas class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libevas.so'! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 4/28/2012 19:21'!
addImage
"
Evas_Object* evas_object_image_filled_add	(Evas * 	e)
Creates a new image object that automatically scales its bound image to the object's area, on both axis.

Parameters:
e	The given canvas.
Returns:
The created image object handle.
This is a helper function around evas_object_image_add() and evas_object_image_filled_set(). It has the same effect of applying those functions in sequence, which is a very common use case.
"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasImage evas_object_image_filled_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 4/28/2012 19:27'!
addLine

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasLine evas_object_line_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/15/2012 03:20'!
addPolygon
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasPolygon evas_object_polygon_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/4/2012 23:44'!
addRectangle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasRectangle evas_object_rectangle_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/6/2012 01:46'!
addText
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasText evas_object_text_add (#NBEvas self))! !

!NBEvas methodsFor: 'adding' stamp: 'EgorScorik 1/15/2012 03:13'!
addTextblock
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCall: #(#NBEvasTextblock evas_object_textblock_add (#NBEvas self))! !

!NBEvas methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 19:41'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEvas methodsFor: 'finding' stamp: 'EgorScorik 10/20/2012 16:39'!
render
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_render (NBEvas self))! !

!NBEvas methodsFor: 'finding' stamp: 'EgorScorik 4/29/2012 04:14'!
topAtX: x Y: y
"Evas_Object* evas_object_top_at_xy_get	(const Evas *e, Evas_Coord x, Evas_Coord y, Eina_Bool include_pass_events_objects, Eina_Bool include_hidden_objects )
Retrieve the Evas object stacked at the top of a given position in a canvas.

Parameters:
e	A handle to the canvas.
x	The horizontal coordinate of the position
y	The vertical coordinate of the position
include_pass_events_objects	Boolean flag to include or not objects which pass events in this calculation
include_hidden_objects	Boolean flag to include or not hidden objects in this calculation
Returns:
The Evas object that is over all other objects at the given position.
This function will traverse all the layers of the given canvas, from top to bottom, querying for objects with areas covering the given position. The user can remove from from the query objects which are hidden and/or which are set to pass events."
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(NBEvasObject evas_object_top_at_xy_get (NBEvas self, int x, int y, 0, 0))! !

NBExternalObject subclass: #NBEvasObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasObject commentStamp: '<historical>' prior: 0!
I am abstract evas object.

http://docs.enlightenment.org/auto/evas/group__Evas__Object__Group.html!

NBEvasObject subclass: #NBEvasImage
	instanceVariableNames: 'imageWidth imageHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasImage commentStamp: '<historical>' prior: 0!
I am raster image.!

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 21:39'!
getImageInfo
	imageWidth := ByteArray new: 4.
	imageHeight := ByteArray new: 4.
	self getImageWidth: imageWidth height: imageHeight.
	imageWidth := imageWidth nbUlongAt: 1.
	imageHeight := imageHeight nbUlongAt: 1.! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 22:17'!
getImageWidth: width height: height
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #( void evas_object_image_size_get (#NBEvasImage self, int* width, int* height))! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageHeight
	^ imageHeight! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageHeight: anObject
	imageHeight := anObject! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageWidth
	^ imageWidth! !

!NBEvasImage methodsFor: 'accessing' stamp: 'EgorScorik 1/5/2012 21:36'!
imageWidth: anObject
	imageWidth := anObject! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 00:27'!
loadErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#int #evas_object_image_load_error_get #(#NBEvasImage #self))! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 00:28'!
loadErrorFromCode: code
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#String #evas_load_error_str #(#int #code))! !

!NBEvasImage methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/5/2012 21:46'!
setFile: aFilename key: key
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_image_file_set (#NBEvasImage self, String aFilename, nil))! !

NBEvasObject subclass: #NBEvasLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasLine commentStamp: '<historical>' prior: 0!
I am line.!

!NBEvasObject class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 11/16/2012 00:04'!
ffiCalloutOptions
	 ^ #( optMayGC )! !

!NBEvasObject class methodsFor: 'as yet unclassified' stamp: 'EgorScorik 10/15/2012 00:41'!
nbLibraryNameOrHandle
	^ '/usr/local/lib/libevas.so'! !

!NBEvasObject methodsFor: 'callbacks' stamp: 'EgorScorik 11/16/2012 00:52'!
addCallback: callback type: type data: data
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self nbCall: #(void evas_object_event_callback_add (NBEvasObject self, int type, NBEvasObjectCallback callback, void* data)) options: #(#optCoerceNilToNull)! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
colorR: r G: g B: b A: a
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_color_set (#NBEvasObject self, int r, int g, int b, int a))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:43'!
free
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_del (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'comparing' stamp: 'EgorScorik 5/7/2012 00:45'!
hash
	^self handle hash.! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
hide
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_hide (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
moveToX: x Y: y
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_move (#NBEvasObject self, int x, int y))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 19:45'!
nbLibraryNameOrHandle
	^ self class nbLibraryNameOrHandle! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
show
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_show (#NBEvasObject self))! !

!NBEvasObject methodsFor: 'nativeboost' stamp: 'EgorScorik 1/4/2012 21:18'!
width: w height: h
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_resize (#NBEvasObject self, int w, int h))! !

NBEvasObject subclass: #NBEvasPolygon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasPolygon commentStamp: '<historical>' prior: 0!
I am polygon.!

NBEvasObject subclass: #NBEvasRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasRectangle commentStamp: '<historical>' prior: 0!
I am rectangle.!

NBEvasObject subclass: #NBEvasText
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasText commentStamp: '<historical>' prior: 0!
I am single line simple text.!

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 01:59'!
setFont: aFontfamily size: size
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_text_font_set (NBEvasText self , String aFontfamily, int size))! !

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 02:02'!
setFontSource: aFilename
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(void evas_object_text_font_source_set (NBEvasText self , String aFilename))! !

!NBEvasText methodsFor: 'as yet unclassified' stamp: 'EgorScorik 1/6/2012 01:58'!
setText: aString
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	^ self nbCall: #(#void #evas_object_text_text_set #(#NBEvasText self , String aString))! !

NBEvasObject subclass: #NBEvasTextblock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Egg-NBEvas'!

!NBEvasTextblock commentStamp: '<historical>' prior: 0!
I am styled multiline text block.!
